unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, NTUserAdmin, Buttons, LMAccess;

type
  TForm1 = class(TForm)
    Button5: TButton;
    Name: TEdit;
    el_Name: TLabel;
    FullName: TEdit;
    el_FullName: TLabel;
    UsrComment: TEdit;
    el_UsrComment: TLabel;
    HomeDir: TEdit;
    el_HomeDir: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    ID: TEdit;
    el_ID: TLabel;
    Profile: TEdit;
    el_Profile: TLabel;
    Button1: TButton;
    NTUserAdmin1: TNTUserAdmin;
    Password: TEdit;
    el_Password: TLabel;
    ConfirmPassword: TEdit;
    el_ConfirmPassword: TLabel;
    ListBox1: TListBox;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Button2: TButton;
    Button3: TButton;
    ListBox2: TListBox;
    Button4: TButton;
    Label1: TLabel;
    Label2: TLabel;
    ServerName: TEdit;
    Label3: TLabel;
    procedure Button5Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Redraw;
    procedure SpeedButton2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FullNameChange(Sender: TObject);
    procedure UsrCommentChange(Sender: TObject);
    procedure HomeDirChange(Sender: TObject);
    procedure ProfileChange(Sender: TObject);
    procedure PasswordChange(Sender: TObject);
    procedure ConfirmPasswordChange(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure NameChange(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox2DblClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ServerNameChange(Sender: TObject);
  private
    function CheckDup( var Box : TListBox; const Name : String ) : boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Redraw;
begin
  Name.Text := NTUserAdmin1.Values.UserName;
  FullName.Text := NTUserAdmin1.Values.FullName;
  UsrComment.Text := NTUserAdmin1.Values.Comment;
  HomeDir.Text := NTUserAdmin1.Values.HomeDir;
  ID.Text := IntToStr( NTUserAdmin1.Values.UserId );
  Profile.Text := NTUserAdmin1.Values.Profile;
  Password.Text := NTUserAdmin1.Values.Password;
  ConfirmPassword.Text := '';
  ListBox1.Items.Assign( NTUserAdmin1.Values.UsersGroups );
  ListBox2.Items.Assign( NTUserAdmin1.Groups );
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  NTUserAdmin1.SetItems;
  Redraw;
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  NTUserAdmin1.Prev;
  Redraw;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  NTUserAdmin1.Next;
  Redraw;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  NTUserAdmin1.ModifyUser;
  Redraw;
end;

procedure TForm1.FullNameChange(Sender: TObject);
begin
  NTUserAdmin1.Values.FullName := FullName.Text;
end;

procedure TForm1.UsrCommentChange(Sender: TObject);
begin
  NTUserAdmin1.Values.Comment := UsrComment.Text;
end;

procedure TForm1.HomeDirChange(Sender: TObject);
begin
  NTUserAdmin1.Values.HomeDir := HomeDir.Text;
end;

procedure TForm1.ProfileChange(Sender: TObject);
begin
  NTUserAdmin1.Values.Profile := Profile.Text;
end;

procedure TForm1.PasswordChange(Sender: TObject);
begin
  NTUserAdmin1.Values.Password := Password.Text;
end;

procedure TForm1.ConfirmPasswordChange(Sender: TObject);
begin
  NTUserAdmin1.Values.ConfirmPassword := ConfirmPassword.Text;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  NTUserAdmin1.First;
  Redraw;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  NTUserAdmin1.Last;
  Redraw;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  NTUserAdmin1.Index := NTUserAdmin1.GetIndexByUserName( Name.Text );
  Redraw;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  st : DWORD;
begin
  st := NTUserAdmin1.AddUser;
  if st = SUCCESS then Redraw
  else Exit;
end;

procedure TForm1.NameChange(Sender: TObject);
begin
  NTUserAdmin1.Values.UserName := Name.Text;
end;

function TForm1.CheckDup( var Box : TListBox; const Name : String ) : boolean;
var
  i : Integer;
  res : boolean;
begin
  res := False;
  for i:=0 to Box.Items.Count-1 do
  begin
    if Box.Items.Strings[i] = Name then
    begin
      res := True;
      break;
    end;
  end;
  Result := res;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
  NTUserAdmin1.RemoveUserFromGroup( ListBox1.Items[ListBox1.ItemIndex] );
  if not CheckDup( ListBox2, ListBox1.Items[ListBox1.ItemIndex] ) then
     ListBox2.Items.Add( ListBox1.Items[ListBox1.ItemIndex] );
  ListBox1.Items.Delete( ListBox1.ItemIndex );
  NTUserAdmin1.Values.UsersGroups.Assign( ListBox1.Items );
end;

procedure TForm1.ListBox2DblClick(Sender: TObject);
begin
  NTUserAdmin1.AddUserToGroup( ListBox2.Items[ListBox2.ItemIndex] );
  if not CheckDup( ListBox1, ListBox2.Items[ListBox2.ItemIndex] ) then
     ListBox1.Items.Add( ListBox2.Items[ListBox2.ItemIndex] );
  ListBox2.Items.Delete( ListBox2.ItemIndex );
  NTUserAdmin1.Values.UsersGroups.Assign( ListBox1.Items );
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if MessageBox( 0, 'Area you sure to delete user?', 'User Manager',
                 MB_YESNO or MB_ICONQUESTION ) = IDNO then Exit; 
  NTUserAdmin1.DeleteUser;
  Redraw;
end;


procedure TForm1.ServerNameChange(Sender: TObject);
begin
  NTUserAdmin1.ServerName := ServerName.Text;
end;

end.
